import { DimensionType } from '@graphpolaris/shared/lib/schema';
import { EncodingSelector } from '.';
import { ElementStats } from '@graphpolaris/shared/lib/data-access/statistics';

export type SelectorType = keyof typeof EncodingSelector;

export type ElementType = 'node' | 'edge';

export type EncodingType = 'label' | 'attribute';

export type Encoding = {
  label?: string;
  marking?: any;
  accessorPath?: string;
  onChange?: (value: any) => void;
  element: ElementType;
  dimension?: DimensionType[];
  selector: SelectorType;
  description?: string;
  condition?: () => boolean;
};

export type SelectorProps = {
  marking: any;
  onChange: (marking: any) => void;
  dimension: DimensionType;
  statistics: ElementStats | undefined;
};

export type EncodingTypes = { [id: string]: Encoding };

export type EncodingProps = { [K in keyof EncodingTypes]?: any };
