import { createSlice, PayloadAction } from '@reduxjs/toolkit';
import type { RootState } from './store';

export type Role = 'creator' | 'viewer';

interface UserState {
  role: Role;
}

const initialState: UserState = {
  role: 'creator',
};

const userSlice = createSlice({
  name: 'user',
  initialState,
  reducers: {
    setRole: (state, action: PayloadAction<Role>) => {
      state.role = action.payload;
    },
  },
});

export const { setRole } = userSlice.actions;

export type { UserState };

export const selectUserRole = (state: RootState) => state.user.role;

export default userSlice.reducer;
